首页 技术 正文
技术 2022年11月17日
0 收藏 880 点赞 3,310 浏览 3674 个字

Problem Descriptionhdu 4750 Count The Pairs(并查集+二分)

With the 60th anniversary celebration of Nanjing University of Science and Technology coming soon, the university sets n tourist spots to welcome guests. Of course, Redwood forests in our university and its Orychophragmus violaceus must be recommended as top ten tourist spots, probably the best of all. Some undirected roads are made to connect pairs of tourist spots. For example, from Redwood forests (suppose it’s a) to fountain plaza (suppose it’s b), there may exist an undirected road with its length c. By the way, there is m roads totally here. Accidently, these roads’ length is an integer, and all of them are different. Some of these spots can reach directly or indirectly to some other spots. For guests, they are travelling from tourist spot s to tourist spot t, they can achieve some value f. According to the statistics calculated and recorded by us in last years, We found a strange way to calculate the value f:
From s to t, there may exist lots of different paths, guests will try every one of them. One particular path is consisted of some undirected roads. When they are travelling in this path, they will try to remember the value of longest road in this path. In the end, guests will remember too many longest roads’ value, so he cannot catch them all. But, one thing which guests will keep it in mind is that the minimal number of all these longest values. And value f is exactly the same with the minimal number.
Tom200 will recommend pairs (s, t) (start spot, end spot points pair) to guests. P guests will come to visit our university, and every one of them has a requirement for value f, satisfying f>=t. Tom200 needs your help. For each requirement, how many pairs (s, t) you can offer?

 Input

Multiple cases, end with EOF.
First line:n m
n tourist spots ( <n<=), spots’ index starts from .
m undirected roads ( <m<=). Next m lines, integers, a b c
From tourist spot a to tourist spot b, its length is c. <a, b<n, c(<c<), all c are different. Next one line, integer, p (<p<=)
It means p guests coming. Next p line, each line one integer, t(<=t)
The value t you need to consider to satisfy f>=t.

 Output

 For each guest's requirement value t, output the number of pairs satisfying f>=t.
Notice, (,), (,) are different pairs.

 Sample Input


 Sample Output


 Source2013 ACM/ICPC Asia Regional Nanjing Online  

题目大意:

给一无向图,n个点,m条边,每条边有个长度,且不一样。定义f(i,j)表示从节点i到节点j的所有路径中的最大边权值的最小值。有q个询问,每个询问有个t,求f(i,j)>=t的种数。

解题思路:

并查集+简单dp+二分。

思路,先按边从小到大排序考虑,对于每条边E该边两个节点为a、b,如果a、b不在同一个联通块,则a联通块中点集A和b联通块中点集B的f值一定为E(因为E升序)。恰好能使其通路。

map[i]表示以权值为i的边作为f值的点对个数。

sum[i]表示以大于等于第i大边权值的权值作为f值得点对总的个数。

对于每一个t,在排序了的sig[i](能取的边权值)中二分找到大于等于它的最小的小标j。输出sum[j]即可。

注意:

求点对个数时要乘以2.

 #pragma comment(linker, "/STACK:1024000000,1024000000")
#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<math.h>
#include<algorithm>
#include<queue>
#include<set>
#include<bitset>
#include<map>
#include<vector>
#include<stdlib.h>
#include <stack>
using namespace std;
#define PI acos(-1.0)
#define max(a,b) (a) > (b) ? (a) : (b)
#define min(a,b) (a) < (b) ? (a) : (b)
#define ll long long
#define eps 1e-10
#define MOD 1000000007
#define N 10006
#define M 600000
#define inf 1e12
int n,m;
struct Node{
int x,y;
int cost;
}node[M];
////////////////////////////////////////////////////
int fa[N];
int cnt[N];
void init(){
for(int i=;i<N;i++){
fa[i]=i;
cnt[i]=;
}
}
int find(int x){
return fa[x]==x?x:fa[x]=find(fa[x]);
} //////////////////////////////////////////////////////
bool cmp(Node a,Node b){
return a.cost<b.cost;
}
////////////////////////////////////////////
int a[M];
int b[M];
int sum[M];
int main()
{
while(scanf("%d%d",&n,&m)==){ for(int i=;i<m;i++){
scanf("%d%d%d",&node[i].x,&node[i].y,&node[i].cost); }
sort(node,node+m,cmp); for(int i=;i<m;i++){
b[i]=node[i].cost;
} memset(a,,sizeof(a)); init();
int ans=;
for(int i=;i<m;i++){
int root1=find(node[i].x);
int root2=find(node[i].y);
if(root1==root2) continue;
fa[root1]=root2;
//ans=ans+2*cnt[root1]*cnt[root2];
a[i]=*cnt[root1]*cnt[root2];
cnt[root2]+=cnt[root1]; } memset(sum,,sizeof(sum));
for(int i=m-;i>=;i--){
sum[i]=sum[i+]+a[i];
} int q;
scanf("%d",&q);
while(q--){
int t;
scanf("%d",&t);
int w=lower_bound(b,b+m,t)-b;
printf("%d\n",sum[w]);
} }
return ;
}
相关推荐
python开发_常用的python模块及安装方法
adodb:我们领导推荐的数据库连接组件bsddb3:BerkeleyDB的连接组件Cheetah-1.0:我比较喜欢这个版本的cheeta…
日期:2022-11-24 点赞:878 阅读:9,022
Educational Codeforces Round 11 C. Hard Process 二分
C. Hard Process题目连接:http://www.codeforces.com/contest/660/problem/CDes…
日期:2022-11-24 点赞:807 阅读:5,513
下载Ubuntn 17.04 内核源代码
zengkefu@server1:/usr/src$ uname -aLinux server1 4.10.0-19-generic #21…
日期:2022-11-24 点赞:569 阅读:6,359
可用Active Desktop Calendar V7.86 注册码序列号
可用Active Desktop Calendar V7.86 注册码序列号Name: www.greendown.cn Code: &nb…
日期:2022-11-24 点赞:733 阅读:6,142
Android调用系统相机、自定义相机、处理大图片
Android调用系统相机和自定义相机实例本博文主要是介绍了android上使用相机进行拍照并显示的两种方式,并且由于涉及到要把拍到的照片显…
日期:2022-11-24 点赞:512 阅读:7,773
Struts的使用
一、Struts2的获取  Struts的官方网站为:http://struts.apache.org/  下载完Struts2的jar包,…
日期:2022-11-24 点赞:671 阅读:4,851